#!/bin/sh
# shuffle.sh
# D. Gibbon
# V01 2004-06-14
# V02 2004-06-15 (dead code removed, comments added)
# V03 2004-06-15  (input check modified to permit piping)
# Shuffle text files (gawk script with shell script wrapper)

# if [ ! -f "$1" ]
# then
# 	echo "  File \"$1\" not found."
# 	echo "  Usage: shuffle.sh textfilename"
# 	echo "         (text file is LF delimited plain ASCII)"
# 	exit
# fi

cat $1 |

gawk '
BEGIN {
	n=0;
}

{
	textlist[n]=$0;
	ordering[n]=NR;
	n++;
}

END {
# Set random seed:
	srand();
	for (i=0; i<n; i++){
		rn=int(rand()*n)
		tmp1=textlist[i];
		textlist[i]=textlist[rn];
		textlist[rn]=tmp1;
		tmp2=ordering[i];
		ordering[i]=ordering[rn];
		ordering[rn]=tmp2;
	}
	for (i=0; i<n; i++){
#		print i+1 ": " textlist[i] "    (" ordering[i] ")";
		print i+1 "=" textlist[i] ;
#		print textlist[i] ;
	}
}
'

